<template>
  <v-container>
    <v-row>
      <v-col cols="5">
        <v-btn @click="doAdd">Add New</v-btn>
      </v-col>
      <v-col cols="7">
        <h1>NMS</h1>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-data-table
            :headers="headers"
            :items="nms"
            :search="search"
            :custom-filter="doSearch"
        >
          <template v-slot:top>
            <v-text-field
                v-model="search"
                label="Search (UPPER CASE ONLY)"
                class="mx-4"
            ></v-text-field>
          </template>
          <template v-slot:[`item.actions`]="{ item }">
            <v-icon small class="mr-2" @click="doEdit(item.id)">mdi-pencil</v-icon>
            <v-icon small @click="doDelete(item)">mdi-delete</v-icon>
          </template>
        </v-data-table>
      </v-col>
    </v-row>
    <NmsForm ref="dlg" />
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import NmsForm from "../components/NmsForm";
import service from "../service/NmsService";

export default {
  name: "Nms",
  components: {
    NmsForm,
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      search: '',
      nms: [],
      title: null,
      headers: [
        {
          text: "ID", align: "center", sortable: true, value: "id", sort: function (a, b) {
            return a < b
          }
        },
        {text: "ACTION", align: "center", value: "actions", sortable: false},
        {text: "NAMA", align: "center", value: "nama", sortable: true},
        {text: "VENDOR", align: "center", value: "vendor", sortable: true},
        {text: "IP SERVER", align: "center", value: "ip_server", sortable: true},
        {text: "PORT", align: "center", value: "port_protocol", sortable: true},
        {text: "CREATE DATE", align: "center", value: "create_at", sortable: true},
        {text: "UPDATE DATE", align: "center", value: "update_at", sortable: true},
      ],
      dialogAdd: false,
      statusProgress: false,
    }
  },
  methods: {
    doSearch(value, search) {
      return value != null &&
          search != null &&
          typeof value === 'string' &&
          value.toString().toUpperCase().indexOf(search) !== -1
    },
    doAdd() {
      let title = "Add New NMS"
      this.$refs.dlg.doAdd(title, false)
    },
    async doDelete(data) {
      if (!await this.$refs.dlgMsg.confirm(`Apakah Ingin Menghapus Data NMS ${data.nama} - ${data.ip_server}`)) {
        return false
      }
      this.statusProgress = true
      await service.delete(data.id).then(async res => {
        let {status, message} = res.data
        if (status === 'SUCCESS') {
          await this.doRefresh()
        }
        this.$refs.dlgMsg.doOpenMsg(message)
      }).catch(ex => {
        console.log(ex)
        this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
      })
      this.statusProgress = false
    },
    doEdit(id) {
      let title = "Edit NMS"
      this.$refs.dlg.doEdit(id, title, true)
    },
    async doRefresh() {
      this.statusProgress = true
      await service.getAll()
        .then(res => {
          let {status, data} = res.data
          if (status === 'SUCCESS') {
            this.nms = data
            for (let nms of this.nms) {
              nms.port_protocol = `${nms.port_tl1}:${nms.protocol}`
            }
          }
        })
      this.statusProgress = false
    }
  },
  mounted() {
    this.doRefresh()
  }
}
</script>

<style scoped>

</style>